﻿Public Class frmDoc

    Private Sub tsmiUndo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiUndo.Click
        ModuleMain.Undo()
    End Sub

    Private Sub tsmiRedo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiRedo.Click
        ModuleMain.Redo()
    End Sub

    Private Sub tsmiCut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiCut.Click
        ModuleMain.Cut()
    End Sub

    Private Sub tsmiCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiCopy.Click
        ModuleMain.Copy()
    End Sub

    Private Sub tsmiPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiPaste.Click
        ModuleMain.Paste()
    End Sub

    Private Sub tsmiFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiFind.Click
        frmFindAndReplace.Show()
    End Sub

    Private Sub tsmiAllSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiAllSelect.Click
        ModuleMain.SelectAll()
    End Sub

    Private Sub tsmiWordWrap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsmiWordWrap.Click
        Me.rtxMain.WordWrap = Me.tsmiWordWrap.Checked
    End Sub

    Public Sub AddNewHandler()
        AddHandler rtxMain.SelectionChanged, AddressOf rtxMain_SelectionChanged
    End Sub

    Public Sub DeleteHandler()
        RemoveHandler rtxMain.SelectionChanged, AddressOf rtxMain_SelectionChanged
    End Sub

    Private Sub frmDoc_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        ModuleMain.ToolBarButtonAndMenuItemEnabled(True)
        frmMain.SliderZoom.Value = Me.rtxMain.ZoomFactor * 100 : Me.tsmiWordWrap.Checked = Me.rtxMain.WordWrap
        If Me.Text.ToString.Replace(" *", "").ToLower.EndsWith(".rtf") = True Or Me.Text.StartsWith("未命名文件") = True Then ModuleMain.FormatEnabled(True) Else ModuleMain.FormatEnabled(False)
    End Sub

    Private Sub frmDoc_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Res As System.Windows.Forms.DialogResult
        If Me.Text.EndsWith(" *") = True Then
            Res = MessageBox.Show("文件 " & Me.Text.Replace(" *", "") & " 已更改，是否保存?", "警告", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning)
            If Res = System.Windows.Forms.DialogResult.Yes Then : ModuleMain.SaveFile()
            ElseIf Res = System.Windows.Forms.DialogResult.Cancel Then : e.Cancel = True
            ElseIf Res = System.Windows.Forms.DialogResult.No Then : e.Cancel = False
            End If
        End If
        ModuleMain.FormatEnabled(True)
        ModuleMain.ToolBarButtonAndMenuItemEnabled(False)
        Me.Dispose()
    End Sub

    Public Enum FileState
        FileChanged = 0
        FileSaved = 1
    End Enum

    Public Sub CurrentFileChangedOrSaved(ByVal FileState As FileState)
        If FileState = FileState.FileChanged Then
            If Me.Text.EndsWith(" *") = False Then Me.Text += " *"
        ElseIf FileState = FileState.FileSaved Then
            Me.Text.Replace(" *", "")
        End If
    End Sub

    Private Sub rtxMain_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtxMain.TextChanged
        CurrentFileChangedOrSaved(FileState.FileChanged)
    End Sub

    Private Sub rtxMain_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkClickedEventArgs) Handles rtxMain.LinkClicked
        System.Diagnostics.Process.Start("iexplorer.exe", e.LinkText)
    End Sub

    Private Sub frmDoc_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.GotFocus
        rtxMain.Focus()
    End Sub

    Private Sub rtxMain_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxMain.SelectionChanged
        If rtxMain.SelectionFont IsNot Nothing Then
            frmMain.ButtonBold.Checked = rtxMain.SelectionFont.Bold
            frmMain.ButtonItalic.Checked = rtxMain.SelectionFont.Italic
            frmMain.ButtonUnderLine.Checked = rtxMain.SelectionFont.Underline
            frmMain.ButtonStrikoutLine.Checked = rtxMain.SelectionFont.Strikeout
            frmMain.ComboFontSize.Text = rtxMain.SelectionFont.Size
            frmMain.ComboFontStyle.Text = rtxMain.SelectionFont.Name
            frmMain.ColorPickerFontColor.SelectedColor = Me.rtxMain.SelectionColor
            If Me.rtxMain.SelectionCharOffset = 0 Then
                frmMain.ButtonSuperScript.Checked = False : frmMain.ButtonSuperScript.Enabled = True : frmMain.ButtonSubScript.Checked = False : frmMain.ButtonSubScript.Enabled = True
            ElseIf Me.rtxMain.SelectionCharOffset < 0 And Me.rtxMain.SelectionCharOffset > -2000 Then
                frmMain.ButtonSuperScript.Checked = False : frmMain.ButtonSuperScript.Enabled = False : frmMain.ButtonSubScript.Checked = True
            ElseIf Me.rtxMain.SelectionCharOffset > 0 And Me.rtxMain.SelectionCharOffset < 2000 Then
                frmMain.ButtonSuperScript.Checked = True : frmMain.ButtonSubScript.Checked = False : frmMain.ButtonSubScript.Enabled = False
            End If
            If rtxMain.SelectionAlignment = HorizontalAlignment.Left Then
                frmMain.ButtonLeft.Checked = True : frmMain.ButtonCenter.Checked = False : frmMain.ButtonRight.Checked = False
            ElseIf rtxMain.SelectionAlignment = HorizontalAlignment.Center Then
                frmMain.ButtonLeft.Checked = False : frmMain.ButtonCenter.Checked = True : frmMain.ButtonRight.Checked = False
            ElseIf rtxMain.SelectionAlignment = HorizontalAlignment.Right Then
                frmMain.ButtonLeft.Checked = False : frmMain.ButtonCenter.Checked = False : frmMain.ButtonRight.Checked = True
            End If
        Else
            frmMain.ButtonBold.Checked = False : frmMain.ButtonItalic.Checked = False
            frmMain.ButtonUnderLine.Checked = False : frmMain.ButtonStrikoutLine.Checked = False
            frmMain.ButtonLeft.Checked = False : frmMain.ButtonCenter.Checked = False : frmMain.ButtonCenter.Checked = False
            frmMain.ComboFontSize.Text = Nothing : frmMain.ComboFontStyle.Text = Nothing
        End If
        frmMain.ButtonBullets.Checked = rtxMain.SelectionBullet
    End Sub
End Class
