﻿Public Class frmFindAndReplace
    Private SearchStartPostion As Integer, OriginalSearch As String
    Private ActiveRichTextBox As System.Windows.Forms.RichTextBox
    Private Enum FindReturnValue : NotFound = -1 : SearchEnd = 0 : End Enum

    Private Function FindText(ByVal Target As String, ByVal Options As System.Windows.Forms.RichTextBoxFinds, ByVal RichTextBox As System.Windows.Forms.RichTextBox) As FindReturnValue
        If Target <> OriginalSearch Then SearchStartPostion = 0
        If Target.Length > 0 Then
            Dim IndexOfText As Integer
            Select Case Options
                Case System.Windows.Forms.RichTextBoxFinds.MatchCase : IndexOfText = RichTextBox.Find(Target, SearchStartPostion, System.Windows.Forms.RichTextBoxFinds.MatchCase)
                Case System.Windows.Forms.RichTextBoxFinds.WholeWord : IndexOfText = RichTextBox.Find(Target, SearchStartPostion, System.Windows.Forms.RichTextBoxFinds.WholeWord)
                Case System.Windows.Forms.RichTextBoxFinds.Reverse : IndexOfText = RichTextBox.Find(Target, SearchStartPostion, System.Windows.Forms.RichTextBoxFinds.Reverse)
                Case System.Windows.Forms.RichTextBoxFinds.None : IndexOfText = RichTextBox.Find(Target, SearchStartPostion, System.Windows.Forms.RichTextBoxFinds.None)
            End Select
            If IndexOfText >= 0 Then : SearchStartPostion = IndexOfText + ActiveRichTextBox.SelectionLength : OriginalSearch = Target : frmMain.Focus()
            ElseIf Target = OriginalSearch Then : MessageBox.Show("已搜索到文件末尾。", "信息", MessageBoxButtons.OK, MessageBoxIcon.Information) : OriginalSearch = Nothing : Return FindReturnValue.SearchEnd
            Else : MessageBox.Show("未找到" & Target, "信息", MessageBoxButtons.OK, MessageBoxIcon.Information) : Return FindReturnValue.NotFound
            End If
        End If
    End Function

    Private Sub btnFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFind.Click
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Me.rdoMathchCase.Checked = True Then : FindText(Me.txtFind.Text, System.Windows.Forms.RichTextBoxFinds.MatchCase, ActiveRichTextBox)
        ElseIf Me.rdoWholeWord.Checked = True Then : FindText(Me.txtFind.Text, System.Windows.Forms.RichTextBoxFinds.WholeWord, ActiveRichTextBox)
        ElseIf Me.rdoReverse.Checked = True Then : FindText(Me.txtFind.Text, System.Windows.Forms.RichTextBoxFinds.Reverse, ActiveRichTextBox)
        Else : FindText(Me.txtFind.Text, System.Windows.Forms.RichTextBoxFinds.None, ActiveRichTextBox)
        End If
    End Sub

    Private Sub btnReplaceFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReplaceFind.Click
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If Me.rdoReplaceMathchCase.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.MatchCase, ActiveRichTextBox)
        ElseIf Me.rdoReplaceWholeWord.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.WholeWord, ActiveRichTextBox)
        ElseIf Me.rdoReplaceReverse.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.Reverse, ActiveRichTextBox)
        Else : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.None, ActiveRichTextBox)
        End If
    End Sub

    Private Sub btnReplace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReplace.Click
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        If ActiveRichTextBox.SelectedText = "" Then
            If Me.rdoReplaceMathchCase.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.MatchCase, ActiveRichTextBox)
            ElseIf Me.rdoReplaceWholeWord.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.WholeWord, ActiveRichTextBox)
            ElseIf Me.rdoReplaceReverse.Checked = True Then : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.Reverse, ActiveRichTextBox)
            Else : FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.None, ActiveRichTextBox)
            End If
        ElseIf ActiveRichTextBox.SelectedText = Me.txtReplaceFind.Text Then
            Dim Text As String = Me.txtReplace.Text, DataObject As DataObject = New DataObject, OldDataOnClipboard As DataObject = Clipboard.GetDataObject
            DataObject.SetData(DataFormats.Text, True, Text)
            Clipboard.SetDataObject(DataObject, True)
            Dim Format As DataFormats.Format = DataFormats.GetFormat(DataFormats.Text)
            ActiveRichTextBox.Paste(Format)
            Clipboard.SetDataObject(OldDataOnClipboard, True) : frmMain.Focus()
        End If
    End Sub

    Private Sub btnReplaceAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReplaceAll.Click
        ActiveRichTextBox = CType(frmMain.ActiveMdiChild.Controls.Item("rtxmain"), System.Windows.Forms.RichTextBox)
        For i As Integer = 0 To ActiveRichTextBox.TextLength
            If ActiveRichTextBox.SelectedText = "" Then
                Dim Res As FindReturnValue
                If Me.rdoReplaceMathchCase.Checked = True Then : Res = FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.MatchCase, ActiveRichTextBox)
                ElseIf Me.rdoReplaceWholeWord.Checked = True Then : Res = FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.WholeWord, ActiveRichTextBox)
                ElseIf Me.rdoReplaceReverse.Checked = True Then : Res = FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.Reverse, ActiveRichTextBox)
                Else : Res = FindText(Me.txtReplaceFind.Text, System.Windows.Forms.RichTextBoxFinds.None, ActiveRichTextBox)
                End If
                If Res = FindReturnValue.NotFound Then Exit For
            ElseIf ActiveRichTextBox.SelectedText = Me.txtReplaceFind.Text Then
                Dim Text As String = Me.txtReplace.Text, DataObject As DataObject = New DataObject, OldDataOnClipboard As DataObject = Clipboard.GetDataObject
                DataObject.SetData(DataFormats.Text, True, Text)
                Clipboard.SetDataObject(DataObject, True)
                Dim Format As DataFormats.Format = DataFormats.GetFormat(DataFormats.Text)
                ActiveRichTextBox.Paste(Format)
                Clipboard.SetDataObject(OldDataOnClipboard, True) : frmMain.Focus()
            End If
        Next
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub btnReplaceClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReplaceClose.Click
        Me.Close()
    End Sub
End Class
